;sample program: data memory move
;author: (c) Benesoczky Zoltan
.device ATmega128
.include "m128def.inc"

.def byte_count = R16			;rename of the registers
.def tmp = R17

		.DSEG		;data segment (RAM

.equ data_num = 16
tomb1:	.BYTE 16	;memory space allocation


		.CSEG		;code segment (FLASH)
		jmp	start


MAIN:
start:	ldi		tmp,low(RAMEND)
		out		SPL,tmp
		ldi		tmp, high(RAMEND)
		out 	SPH,tmp
	
		;fill memory to incremented values
		ldi		XL,low(tomb1)
		ldi		XH,high(tomb1)
		LDI		byte_count,data_num
		CLR		tmp
cycle1: ST		X+,tmp
		inc		tmp
	    DEC		byte_count
	    BRNE	cycle1
loop_MAIN:

		LDI		ZL, Low(tomb1)
		LDI		ZH, High(tomb1) 	;Z=tomb_cim
		LDD 	R1,Z+1			  	;R1=tomb[1]
		LDD 	R2,Z+2			  	;R2=tomb[2]
		ADD		R1,R2			  	;eredmny R1-ben
loop_endless:
		jmp		loop_endless




