;sample program: string copy from FLASH to RAM
;author: (c) Benesoczky Zoltan

.device ATmega328P

.equ RAM_START = 0x100 
.equ constant1 = 0xaa		;definition of constatnt

.def byte_num = R16			;rename of the registers
.def tmp	 = R17

		.DSEG		;data segment (RAM)
		.ORG		RAM_START
str_var1:
		.BYTE 16	;memory space allocation

		.CSEG		;code segment (FLASH)		

		jmp	start


string1:.DB "string1",0x00
.set string1_addr = (string1 << 1) ;FLASH is word organized, we need address in bytes


MAIN:
start:	ldi		tmp,low(RAMEND)
		out		SPL,tmp
		ldi		tmp, high(RAMEND)
		out 	SPH,tmp

loop_MAIN:
		LDI		YL,Low(str_var1)
	    LDI		YH,High(str_var1)		;Y=ram_cim
	    LDI		ZL, Low(string1_addr)
	    LDI		ZH, High(string1_addr)	;Z=string_cim

cycle1:	LPM								;R0=CODE (Z)
	    ST		Y+,R0					;RAM (Y)=R0
	    ADIW	ZL,1			 		;Z=Z+1
		OR		R0,R0					;string end: 0x00
	    BRNE	cycle1

loop_endless:
		jmp	loop_endless





