.device ATmega328p

.equ LED_mask = 1 << 5	;LED on PORTB(5) 


.def tmp1 = R16			;rename of the registers
.def tmp2 = R17
.def cntl = R18
.def cnth = R19


		.CSEG			;code segment (FLASH)
		jmp	start

							//number of clk period
Delay:	ldi tmp1, 132		//1
dlyloop:dec tmp1			//1
		brne dlyloop		//2/1
		sbiw x, 1			//2
		;subi xl,1
		;sbci xh,0
		brne Delay			//2/1
		ret					//4

Start:  ldi		tmp1,low(RAMEND)
		out		SPL,tmp1
		ldi		tmp1, high(RAMEND)
		out 	SPH,tmp1
		;initialisations
		
		ldi		tmp1,LED_mask
		out		DDRB,tmp1			;set output PORTD(5)
		
loop_MAIN:
		;in		tmp1,PORTB
		;ldi	tmp2,LED_mask		
		;eor	tmp1,tmp2			;toggle LED
		;out	PORTB,tmp1
		
		ldi		tmp2,LED_mask
		out		PINB,tmp2			;ATmega328: write to pin toggle the port

		ldi		xh,high(20000)
		ldi		xl,low(20000)
		call	Delay		

		jmp		loop_MAIN
